var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PureComponent, Component } from 'react';
import { Modal, List } from 'antd-mobile';
import './index.less';

var Item = List.Item;
var prefixCls = 'eh-select-organization';

function closest(el, selector) {
  var matchesSelector = el.matches || el.webkitMatchesSelector || el.mozMatchesSelector || el.msMatchesSelector;
  while (el) {
    if (matchesSelector.call(el, selector)) {
      return el;
    }
    el = el.parentElement;
  }
  return null;
}

var SelectOrganization = function (_ref) {
  _inherits(SelectOrganization, _ref);

  function SelectOrganization() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, SelectOrganization);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = SelectOrganization.__proto__ || Object.getPrototypeOf(SelectOrganization)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
      visible: false
    }, _this.onWrapTouchStart = function (e) {
      // fix touch to scroll background page on iOS
      if (!/iPhone|iPod|iPad/i.test(navigator.userAgent)) {
        return;
      }
      var pNode = closest(e.target, '.am-modal-content');
      if (!pNode) {
        e.preventDefault();
      }
    }, _this.onClose = function () {
      var onClose = _this.props.onClose;
      // this.setState({ visible: false });

      onClose && onClose();
    }, _this.onChose = function (org) {
      var _this$props = _this.props,
          onClose = _this$props.onClose,
          onChose = _this$props.onChose;

      onChose && onChose(org);
      onClose && onClose();
      // this.setState({ visible: false });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(SelectOrganization, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props$visible = this.props.visible,
          visible = _props$visible === undefined ? false : _props$visible;

      this.setState({ visible: visible });
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.visible !== nextProps.visible) {
        this.setState({ visible: nextProps.visible });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var visible = this.state.visible;
      var _props = this.props,
          dataList = _props.dataList,
          _props$nameKey = _props.nameKey,
          nameKey = _props$nameKey === undefined ? 'name' : _props$nameKey,
          _props$idKey = _props.idKey,
          idKey = _props$idKey === undefined ? 'id' : _props$idKey;

      if (!visible) {
        return null;
      }
      return React.createElement(
        'div',
        { className: prefixCls },
        React.createElement(
          Modal,
          {
            visible: visible,
            transparent: true,
            maskClosable: false,
            onClose: this.onClose,
            title: '\u8BF7\u9009\u62E9\u4F01\u4E1A',
            footer: [{ text: '取消', onPress: function onPress() {
                return _this2.onClose();
              } }],
            wrapProps: { onTouchStart: this.onWrapTouchStart },
            className: prefixCls
          },
          React.createElement(
            List,
            null,
            dataList.map(function (org) {
              return React.createElement(
                Item,
                { key: org[idKey], onClick: function onClick() {
                    return _this2.onChose(org);
                  } },
                org[nameKey] || ''
              );
            })
          )
        )
      );
    }
  }]);

  return SelectOrganization;
}(PureComponent || Component);

export default SelectOrganization;